glibmm: Gio::SocketAddress Class Reference

glibmm 2.46.3

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::SocketAddress Class Reference
Portable Network I/O Functionality

Abstract base class representing endpoints for socket communication. More...

`#include <giomm/socketaddress.h>`

Inheritance diagram for Gio::SocketAddress:
[legend]

## Public Member Functions
| SocketAddress (SocketAddress&& src) noexcept
SocketAddress& | operator= (SocketAddress&& src) noexcept
virtual | ~SocketAddress () noexcept
GSocketAddress* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketAddress* | gobj () const
| Provides access to the underlying C GObject. More...
GSocketAddress* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
SocketFamily | get_family () const
| Gets the socket family type of address. More...
bool | to_native (gpointer dest, gsize destlen)
| Converts a SocketAddress to a native struct sockaddr, which can be passed to low-level functions like connect() or bind(). More...
gssize | get_native_size () const
| Gets the size of address's native struct sockaddr. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< SocketFamily > > | property_family () const
| The family of the socket address. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gio::SocketConnectable
| SocketConnectable (SocketConnectable&& src) noexcept
SocketConnectable& | operator= (SocketConnectable&& src) noexcept
virtual | ~SocketConnectable () noexcept
GSocketConnectable* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketConnectable* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< SocketAddressEnumerator > | enumerate ()
| Creates a SocketAddressEnumerator for connectable. More...
Glib::RefPtr< const SocketAddressEnumerator > | enumerate () const
| Creates a SocketAddressEnumerator for connectable. More...
Glib::RefPtr< SocketAddressEnumerator > | proxy_enumerate ()
| Creates a SocketAddressEnumerator for connectable that will return ProxyAddresses for addresses that you must connect to via a proxy. More...
Glib::RefPtr< const SocketAddressEnumerator > | proxy_enumerate () const
| Creates a SocketAddressEnumerator for connectable that will return ProxyAddresses for addresses that you must connect to via a proxy. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface () noexcept
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< SocketAddress > | create (gpointer native, gsize len)
Static Public Member Functions inherited from Gio::SocketConnectable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::SocketAddress > | wrap (GSocketAddress* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::SocketConnectable
Glib::RefPtr< Gio::SocketConnectable > | wrap (GSocketConnectable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify) (gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object () noexcept
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)
Protected Member Functions inherited from Gio::SocketConnectable
| SocketConnectable ()
| You should derive from this class to use it. More...

## Detailed Description

Abstract base class representing endpoints for socket communication.

Since glibmm 2.24:

## Constructor & Destructor Documentation

Gio::SocketAddress::SocketAddress | ( | SocketAddress&& | src | ) |
| noexcept

virtual Gio::SocketAddress::~SocketAddress | ( |  | ) |
| virtualnoexcept

## Member Function Documentation

static Glib::RefPtr<SocketAddress> Gio::SocketAddress::create | ( | gpointer | native,
|  | gsize | len
| ) |  |
| static

SocketFamily Gio::SocketAddress::get_family | ( |  | ) | const

Gets the socket family type of address.

Since glibmm 2.22:

Returns
  The socket family type of address.

gssize Gio::SocketAddress::get_native_size | ( |  | ) | const

Gets the size of address's native struct sockaddr.

You can use this to allocate memory to pass to g_socket_address_to_native().

Since glibmm 2.22:

Returns
  The size of the native struct sockaddr that address represents.

static GType Gio::SocketAddress::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GSocketAddress* Gio::SocketAddress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GSocketAddress* Gio::SocketAddress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GSocketAddress* Gio::SocketAddress::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

SocketAddress& Gio::SocketAddress::operator= | ( | SocketAddress&& | src | ) |
| noexcept

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<SocketFamily> > Gio::SocketAddress::property_family | ( |  | ) | const

The family of the socket address.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

bool Gio::SocketAddress::to_native | ( | gpointer | dest,
|  | gsize | destlen
| ) |  |

Converts a SocketAddress to a native struct sockaddr, which can be passed to low-level functions like connect() or bind().

If not enough space is available, a IO_ERROR_NO_SPACE error is returned. If the address type is not known on the system then a IO_ERROR_NOT_SUPPORTED error is returned.

Since glibmm 2.22:

Parameters

  dest | A pointer to a memory location that will contain the native struct sockaddr.
  destlen | The size of dest. Must be at least as large as g_socket_address_get_native_size().

Returns
  `true` if dest was filled in, `false` on error.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::SocketAddress > wrap | ( | GSocketAddress * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.